unittest和Robot Framework这两种框架的区别

最近在考虑用python +selenium+unittest或robot Framework 来做web的UI自动化测试,有没有大佬可以给讲讲这两个框架的区别,优缺点啊?
(C币余额不足了,能不能帮忙解答下啊)

1个回答

robotframework对python的兼容不知道怎样,unittest会python就可以

Csdn user default icon
上传中...
上传图片
插入图片
抄袭、复制答案,以达到刷声望分或其他目的的行为,在CSDN问答是严格禁止的,一经发现立刻封号。是时候展现真正的技术了!
其他相关推荐
使用unittest框架编写的自动化测试代码,中在调用执行测试用例问题,急用

1、详细说明,有两个文件分别使用unittest单元测试框架编写了两个模块的用例,分别是登录成功模块,和登录成功后进行操作的模块。 2、在构造测试集的时候出现先一个想法,我想把登录成功用例作为登录成功后实行的操作功能的前置条件。 3、简述就是把一个文件中其中一个用例执行完成作为另外一个文件中的一个用例执行的前置条件,使用unittest框架怎么实现或python代码怎么实现。急用

selenium unittest中框架报错

```from selenium import webdriver from selenium.webdriver.support.select import Select from time import sleep import unittest driver=None class Webtours(unittest.TestCase): @classmethod def setUpClass(cls): global driver driver=webdriver.Ie() @classmethod def tearDownClass(cls): driver.quit() def testOpenWeb(self): driver.get("http://localhost:1080/webtours") sleep(3) def testLogin(self): sleep(3) driver.switch_to.default_content() driver.switch_to.frame("body") driver.switch_to.frame("navbar") driver.find_element_by_name("username").send_keys("zhangsan1") driver.find_element_by_name("password").send_keys("1") driver.find_element_by_name("login").click() sleep(3) ``` 报错如下 During handling of the above exception, another exception occurred: Traceback (most recent call last): File "C:\Users\admin\Desktop\WebTours.py", line 21, in testLogin driver.switch_to.frame("body") File "E:\Python\Python36-32\lib\site-packages\selenium\webdriver\remote\switch_to.py", line 87, in frame raise NoSuchFrameException(frame_reference) selenium.common.exceptions.NoSuchFrameException: Message: body ---------------------------------------------------------------------- Ran 2 tests in 15.415s FAILED (errors=1) >>>

请教下unittest源码中的这一句有什么作用?

在python的unittest库里,主要文件中都有这么一句: __unittest = True 全程没见在哪用到,哪位能帮忙看看这样的写法主要是什么作用呢? 找到了社区推荐的答案,谢谢各位: https://blog.csdn.net/nitibu/article/details/48392679

Python unittest中一个用例使用多套数据的情况怎么处理?

尝试在unittest中一个用例使用多套数据,代码如下,请高手指点一下: Data.py文件 ``` #coding=utf-8 adict = {"key1":"value1","key2":"value2","key3":"value3"} bdict = {"key1":"valuea","key2":"valueb","key3":"valuec"} ``` Case.py文件 ``` #coding=utf-8 import unittest,time import HTMLTestRunner import Data class MyTestCase(unittest.TestCase): dict = {} def SetData(dict): MyTestCase.dict = dict def testCase1(self): print self.dict["key1"] print self.dict["key2"] self.assertEqual("a","a") def testCase2(self): print self.dict["key1"] print self.dict["key2"] self.assertEqual("b","b") def Suite1(): suiteTest = unittest.TestSuite() MyTestCase.dict = Data.adict suiteTest.addTest(MyTestCase("testCase1")) suiteTest.addTest(MyTestCase("testCase2")) return suiteTest def Suite2(): suiteTest = unittest.TestSuite() MyTestCase.dict = Data.bdict suiteTest.addTest(MyTestCase("testCase1")) suiteTest.addTest(MyTestCase("testCase2")) return suiteTest if __name__ == '__main__': #确定生成报告的路径 suite = unittest.TestSuite((Suite1(),Suite2())) filePath = "D:/pyResult.html" fp = file(filePath,'wb') #生成报告的Title,描述 runner = HTMLTestRunner.HTMLTestRunner(stream=fp,title='Python Test Report',description='This is Python Report') runner.run(suite) fp.close() ``` 问题: 我在Suite1()和Suite2()中分别用了adict和bdict两组数据,但在报告中实际使用的都是bdict中的数据,不知道为啥啊,请高手指点一下,非常感谢。 ![图片说明](https://img-ask.csdn.net/upload/201706/17/1497698684_36033.jpg)

python--unittest测试运行成功没有出现句点,我用的pycharm

最开始我按照书上代码运行,显示Ran 0 tests in 0.000s,具体代码如下 (复制上来代码里很多缩进都没了,将就看下,代码是没有报错的,主要是测试有问题) 待测试代码: #name_function.py def get_formatted_name(first,last): '''piease enter your full name''' full_name = first + ' ' + last return full_name.title() 测试代码: import unittest from name_function import get_formatted_name class NameTestCase(unittest.TestCase): '''测试name_function.py''' def test_first_last_name(self): '''能否正确处理名字''' formatted_name = get_formatted_name('jian','ming') self.assertEqual(formatted_name,'Jian Ming') unittest.main() 运行结果: Launching unittests with arguments python -m unittest E:/python code/test_name_function.py in E:\python code ---------------------------------------------------------------------- Ran 0 tests in 0.000s OK Process finished with exit code 0 Empty test suite. 之后我在网上找到了两种解决方案 方案一: 将测试代码处的 unittest.main() 修改为 if __name__ == '__main__': unittest.main() 运行结果为 Launching unittests with arguments python -m unittest E:/python code/test_name_function.py in E:\python code Ran 1 test in 0.001s OK 没有句点,而书上运行结果如下,是有句点的 . ---------------------------------------------------------------------- Ran 1 test in 0.000s OK 方案二: 对get_formatted_name()进行测试 步骤如下: 选中该方法后ctrl+shift+T,如图 ![图片说明](https://img-ask.csdn.net/upload/201711/17/1510888257_266413.png) 选择creat New Test,选中该方法。测试代码如下 import unittest from name_function import get_formatted_name class NameTestCase(unittest.TestCase): '''测试name_function.py''' def test_first_last_name(self): '''能否正确处理名字''' formatted_name = get_formatted_name('jian','ming') self.assertEqual(formatted_name,'Jian Ming') 就是相比于书上代码,删掉了unittest.main() 运行结果同方案一,为什么会没有句点呢?

unittest测试时,testsuite只能执行第一个用例,单独的用例都可以执行,这是为什么

代码为: class Count: def __init__(self,a,b): self.a = int(a) self.b = int(b) def add(self): return self.a + self.b from calculator import Count import unittest class TestCount(unittest.TestCase): def setUp(self): print('test start') def test_add(self): j = Count(2,3) self.assertEqual(j.add(),5) def test_add2(self): j = Count(41,76) self.assertEqual(j.add(),117) def tearDown(self): print('test end') if __name__ == "__main__": suite = unittest.TestSuite() suite.addTest(TestCount('test_add2')) suite.addTest(TestCount('test_add')) runner = unittest.TextTestRunner() runner.run(suite) 错误为: Traceback (most recent call last): File "<ipython-input-6-e4fc42a6bc0e>", line 1, in <module> runfile('E:/python-workspace/zidonghua/unittest/testsuite_texttestrunner_calculator.py', wdir='E:/python-workspace/zidonghua/unittest') File "C:\Users\liushu\Anaconda2\lib\site-packages\spyder\utils\site\sitecustomize.py", line 866, in runfile execfile(filename, namespace) File "C:\Users\liushu\Anaconda2\lib\site-packages\spyder\utils\site\sitecustomize.py", line 87, in execfile exec(compile(scripttext, filename, 'exec'), glob, loc) File "E:/python-workspace/zidonghua/unittest/testsuite_texttestrunner_calculator.py", line 34, in <module> runner.run(suite) File "C:\Users\liushu\Anaconda2\lib\unittest\runner.py", line 151, in run test(result) File "C:\Users\liushu\Anaconda2\lib\unittest\suite.py", line 70, in __call__ return self.run(*args, **kwds) File "C:\Users\liushu\Anaconda2\lib\unittest\suite.py", line 108, in run test(result) File "C:\Users\liushu\Anaconda2\lib\unittest\case.py", line 393, in __call__ return self.run(*args, **kwds) File "C:\Users\liushu\Anaconda2\lib\unittest\case.py", line 368, in run result.addSuccess(self) File "C:\Users\liushu\Anaconda2\lib\unittest\runner.py", line 63, in addSuccess self.stream.flush() IOError: [Errno 9] Bad file descriptor

python 3.6 unittest没有testcase属性

python 3.6 unittest没有testcase属性![图片说明](https://img-ask.csdn.net/upload/201801/27/1517061590_384216.png)

selenium单元测试用例调用不了,提示<unittest.suite.TestSuite tests=[<unittest.suite.TestSuite tests=[<unittest.loader._FailedTest testMethod=test_login>]>]>,只执行登录文件没有问题

错误日志如下 ![图片说明](https://img-ask.csdn.net/upload/202004/02/1585818429_774831.png) ``` test_login代码如下: from time import sleep import unittest import random, sys sys.path.append('test_case/models') sys.path.append('test_case/page_obj') from .models import myunit, function from .page_obj.loginPage import login class TestLogin(myunit.MyTest): '''社区登录测试''' # 测试用户登录 def user_login_verify(self, username, password): login(self.driver).user_login(username, password) def test_login(self): '''用户名密码正确''' self.user_login_verify("cs", "Cs88888") sleep(2) po = login(self.driver) self.assertEqual(po.user_login_success(), "消防管理信息系统") function.insert_img(self.driver, "user_pawd_ture.jpg") if __name__ == "__main__": unittest.main() ``` ``` 主文件如下 from HTMLTestRunner import HTMLTestRunner from email.mime.text import MIMEText from email.header import Header import smtplib import unittest import time import os if __name__ == '__main__': fp = open('./bbs/report/result.html', 'wb') # 创建测试报告,以写的方式存入某个路径 runner = HTMLTestRunner(stream=fp, title="测试报告", description="用例执行情况:") test_dir = 'D:/mztestpro/bbs/test_case' discover = unittest.defaultTestLoader.discover(test_dir, pattern='test_*.py') runner.run(discover) fp.close() ```

python unittest执行程序在pycharm可以成功运行但使用cmd会报错

如题,在pycharm中执行主程序运行成功: 已连接主机 登录成功 正在发送...... 邮件发送完成~ Process finished with exit code 0 在cmd执行主程序报错: Traceback (most recent call last): File"all_test.py",line 32,in<module> alltestnames = creatsuite() File"all_test.py",line 27,in creatsuite testunit.addTests(test_case) File "C:\Python37\lib\unittest\suite.py",line57,in addTests for test in tests: TypeError:'_FailedTest'object is not iterable 报错的程序代码是这部分: def creatsuite(): testunit = unittest.TestSuite() test_dir = test_suite_dir package_tests = unittest.defaultTestLoader.discover(test_dir, pattern='*.py', top_level_dir=None) for test_suite in package_tests: for test_case in test_suite: testunit.addTests(test_case) print(testunit) return testunit 刚接触接口测试,请问是哪里出了问题呢?因为正在jenkins构建项目执行,把源码放在github后使用windows批处理命令执行,这样进程是停滞的,也结束不了。

python3 unittest怎么做到上一个测试用例失败时自动跳过一下个测试用例

比如登录失败时,就跳过退出登录的用例,示例代码如下,大神求教,应该怎么写才能达到跳过的效果,如果使用@unittest.skipIf(),但是我怎么知道上个用例失败了呢 ``` import unittest class TestDemo(unittest.TestCase): @classmethod def setUpClass(cls): print("setupclass") def setUp(self): print("setup") def test_login(self): print("test_login") self.assertEqual(1, 2) # 这里让登录判断为失败 def test_logout(self): print("test_logout") def tearDown(self): print("teardown") @classmethod def tearDownClass(cls): print("teardownclass") if __name__ == "__main__": testsuite = unittest.TestSuite() testsuite.addTest(TestDemo("test_login")) testsuite.addTest(TestDemo("test_logout")) runner = unittest.TextTestRunner() runner.run(testsuite) ```

unittest,selenium驱动浏览器的时候,浏览器只能打开一次是什么问题????、?

源码: ``` from selenium import webdriver driver=webdriver.Chrome() import unittest class Test_selenium(unittest.TestCase): def setUp(self) -> None: driver.get('https://cn.bing.com/') def tearDown(self) -> None: driver.quit() def test_add1(self): pass def test_add2(self): pass if __name__ == '__main__': unittest.main() ``` 报错信息 ``` Testing started at 20:40 ... E:\GitHub\Web_Framework\venv\Scripts\python.exe "E:\Program Files\JetBrains\PyCharm Community Edition 2019.2.5\helpers\pycharm\_jb_unittest_runner.py" --target test1.Test_selenium Launching unittests with arguments python -m unittest test1.Test_selenium in E:\GitHub\Python_Study\20200221 Error Traceback (most recent call last): File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\connection.py", line 156, in _new_conn conn = connection.create_connection( File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\util\connection.py", line 84, in create_connection raise err File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\util\connection.py", line 74, in create_connection sock.connect(sa) ConnectionRefusedError: [WinError 10061] 由于目标计算机积极拒绝,无法连接。 During handling of the above exception, another exception occurred: Traceback (most recent call last): File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\connectionpool.py", line 665, in urlopen httplib_response = self._make_request( File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\connectionpool.py", line 387, in _make_request conn.request(method, url, **httplib_request_kw) File "E:\Program Files\Python\Python3.8\lib\http\client.py", line 1230, in request self._send_request(method, url, body, headers, encode_chunked) File "E:\Program Files\Python\Python3.8\lib\http\client.py", line 1276, in _send_request self.endheaders(body, encode_chunked=encode_chunked) File "E:\Program Files\Python\Python3.8\lib\http\client.py", line 1225, in endheaders self._send_output(message_body, encode_chunked=encode_chunked) File "E:\Program Files\Python\Python3.8\lib\http\client.py", line 1004, in _send_output self.send(msg) File "E:\Program Files\Python\Python3.8\lib\http\client.py", line 944, in send self.connect() File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\connection.py", line 184, in connect conn = self._new_conn() File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\connection.py", line 168, in _new_conn raise NewConnectionError( urllib3.exceptions.NewConnectionError: <urllib3.connection.HTTPConnection object at 0x0000020FBA782100>: Failed to establish a new connection: [WinError 10061] 由于目标计算机积极拒绝,无法连接。 During handling of the above exception, another exception occurred: Traceback (most recent call last): File "E:\Program Files\Python\Python3.8\lib\unittest\case.py", line 60, in testPartExecutor yield File "E:\Program Files\Python\Python3.8\lib\unittest\case.py", line 672, in run self._callSetUp() File "E:\Program Files\Python\Python3.8\lib\unittest\case.py", line 630, in _callSetUp self.setUp() File "E:\GitHub\Python_Study\20200221\test1.py", line 8, in setUp driver.get('https://cn.bing.com/') File "E:\Program Files\Python\Python3.8\lib\site-packages\selenium\webdriver\remote\webdriver.py", line 333, in get self.execute(Command.GET, {'url': url}) File "E:\Program Files\Python\Python3.8\lib\site-packages\selenium\webdriver\remote\webdriver.py", line 319, in execute response = self.command_executor.execute(driver_command, params) File "E:\Program Files\Python\Python3.8\lib\site-packages\selenium\webdriver\remote\remote_connection.py", line 374, in execute return self._request(command_info[0], url, body=data) File "E:\Program Files\Python\Python3.8\lib\site-packages\selenium\webdriver\remote\remote_connection.py", line 397, in _request resp = self._conn.request(method, url, body=body, headers=headers) File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\request.py", line 79, in request return self.request_encode_body( File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\request.py", line 171, in request_encode_body return self.urlopen(method, url, **extra_kw) File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\poolmanager.py", line 330, in urlopen response = conn.urlopen(method, u.request_uri, **kw) File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\connectionpool.py", line 747, in urlopen return self.urlopen( File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\connectionpool.py", line 747, in urlopen return self.urlopen( File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\connectionpool.py", line 747, in urlopen return self.urlopen( File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\connectionpool.py", line 719, in urlopen retries = retries.increment( File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\util\retry.py", line 436, in increment raise MaxRetryError(_pool, url, error or ResponseError(cause)) urllib3.exceptions.MaxRetryError: HTTPConnectionPool(host='127.0.0.1', port=13604): Max retries exceeded with url: /session/5a91f5a3ba7b7efd9309a569fffeeb9d/url (Caused by NewConnectionError('<urllib3.connection.HTTPConnection object at 0x0000020FBA782100>: Failed to establish a new connection: [WinError 10061] 由于目标计算机积极拒绝,无法连接。')) Assertion failed Ran 2 tests in 12.993s FAILED (errors=1) Process finished with exit code 1 Assertion failed Assertion failed ```

python unittest 问题

import unittest, my_math class ProductTestCase(unittest.TestCase): def testInteger(self): for x in xrange(-10,10): for y in xrange(-10,10): p = my_math.product(x,y) self.failUnless(p ==x*y, 'Interger multi failed') def testFloats(self): for x in xrange(-10,10): for y in xrange(-10,10): x = x/10.0 y = y/10.0 p = my_math.product(x,y) self.failUnless(p ==x*y,'float multi failed') if __name__ == '__main__': unittest.main() 修改 def testFloats(self): 为 def tesrFloats(self): 为什么检测结果就变化。 前者检测到两个。后者仅仅检测到一个

怎么获得unittest返回值,也就是代码中的 return str

``` #-*- coding: UTF-8 -*- from threading import Timer import time from selenium import webdriver from nose_parameterized import parameterized import unittest class TestAdd(unittest.TestCase): def setUp(self): self.driver=webdriver.Chrome() self.driver.maximize_window() self.driver.get("http://www.juxiangyou.com") @parameterized.expand([ ('syt350964652@QQ.com'), ('syt350964653@QQ.com'), ]) def test_add(self,username): driver=self.driver driver.find_element_by_id('account').send_keys(username) time.sleep(5) driver.find_element_by_id('password').send_keys('111') time.sleep(11) driver.find_element_by_link_text('登 录').click() time.sleep(2) dqjb=self.driver.current_window_handle driver.find_element_by_link_text('匠神部落').click() time.sleep(2) list_jb=self.driver.window_handles for jb in list_jb: if jb!=dqjb: jb_two=jb driver.switch_to.window(jb_two) driver.find_element_by_id('forgeHall').click() time.sleep(2) time_num=self.driver.find_element_by_class_name('forge').text print(time_num[-8:]) str=time_num[-8:] return str def tearDown(self): self.driver.quit() if __name__=='__main__': unittest.main() ```

创建测试套件时,unittest.makeSuit报黄,显示错误,不自动弹出,希望有知道怎么解决的告知一下

import unittest from TestCase.LoginCase import Login from Tools.PythonHelpApi import API def testsuite(): regsuite=unittest.TestSuite() regsuite.addTest(unittest.makesuit) regsuite.addTest(Login('testLogin1')) regsuite.addTest(Login('testLogin2')) regsuite.addTest(Login('testLogin3')) regsuite.addTest(Login('testLogin4')) regsuite.addTest(Login('testLogin5')) Title = "登录自动化测试报告" D = "登录共五条用例,分别做不同的业务处理" FUBTAPI().CreatHtmlreport("Login", Title, D, regsuite) if __name__ == '__main__': testsuite()

unittest中的assertEqual代码为什么不被执行

import unittest from unit import hou class NamesTestCase(unittest.TestCase): def test_first_last_name(self): formatted_name = hou('janis', 'joplin') self.assertEqual(formatted_name,'Janis Joplin') unittest.main() 首先导入unittest,然后从unit文件导入hou函数 创建一个NamesTestCase类 创建一个test_first_last_name方法 新建一个变量formatted_name,值为将('janis','joplin') 使用assertEquql判断将值代入hou,函数后,结果是否为'janis joplin') 现在的情况 是使用代码调试功能,进行调试时,发现代码走到unittest.main()后不再往上走了,而是结束了,请明白的人告知,谢谢!加上if__name__=='__main__'时又可以运行,为什么不加这行又不可以。本人在初学python,看到书上的代码是没有if这个判断,也是可以运行的,我自己把代码复制过来,都运行不了。请问问题出在哪里了。是python版本的问题,求告知!

python 使用unittest写脚本遇到的问题

![图片说明]![图片说明](https://img-ask.csdn.net/upload/201909/09/1567998684_245139.png) 如图所示的代码,会报错 AttributeError: 'TestKS' object has no attribute 'find_element_by_xpath' 但是如果将test_A的代码写到setUp那里,就不会如此了 请问,我应该怎么修改

Unittest时报了java.lang.NoClassDefFoundError:

Unittest时报了java.lang.NoClassDefFoundError: oracle/as/config/persistence/PersistenceManager这个错,是什么原因

去unittest无法加载文件

<div class="post-text" itemprop="text"> <p>1、<code>go test config_test.go</code>,always file,error: open conf/config.yml: The system cannot find the path specified 2、source code is ok 3、how do <code>go test file</code> sucess in different directory </p> </div>

python + unittest 通过读取excell文件中的数据进行接口的测试,每次执行一行

最近在做接口的测试,想通过读取excel里面的数据进行接口的测试,想达到的目标是,执行一次testcase,读取一行数据。在执行testcase的时候里面的参数通过读取Excel,将参数和断言赋值。 ``` class MyTestCase(unittest.TestCase): """ 每执行一次,读取excel一行数据,通过读取Excel的行数去确定执行的次数 """ @classmethod def setUpClass(cls) -> None: cls.service_name = "com.tz.course.stub.service.IServicePromiseFacadeAPI"# 通过读取Excel赋值 cls.method_name = "getServicePromise" #通过Excel赋值 def tearDownClass(cls) -> None: pass def test_errorIServicePromiseFacadeAPI(self): parm = "xyy" #通过读取excel进行赋值 oppen = RefundControl() result = oppen.request_Dubbo(self.service_name, self.method_name, parm) print("result:", result, type(result)) ass = '{"sucess": True}' #通过Excel赋值 # rsj = json.loads(result) # print("rsj类型:", rsj, type(rsj)) # results = rsj["results"] self.assertNotIn(ass, result) ``` 求大佬给个具体的样例参考一下。

学Python后到底能干什么?网友:我太难了

感觉全世界营销文都在推Python,但是找不到工作的话,又有哪个机构会站出来给我推荐工作? 笔者冷静分析多方数据,想跟大家说:关于超越老牌霸主Java,过去几年间Python一直都被寄予厚望。但是事实是虽然上升趋势,但是国内环境下,一时间是无法马上就超越Java的,也可以换句话说:超越Java只是时间问题罢。 太嚣张了会Python的人!找工作拿高薪这么简单? https://edu....

在中国程序员是青春饭吗?

今年,我也32了 ,为了不给大家误导,咨询了猎头、圈内好友,以及年过35岁的几位老程序员……舍了老脸去揭人家伤疤……希望能给大家以帮助,记得帮我点赞哦。 目录: 你以为的人生 一次又一次的伤害 猎头界的真相 如何应对互联网行业的「中年危机」 一、你以为的人生 刚入行时,拿着傲人的工资,想着好好干,以为我们的人生是这样的: 等真到了那一天,你会发现,你的人生很可能是这样的: ...

为什么程序猿都不愿意去外包?

分享外包的组织架构,盈利模式,亲身经历,以及根据一些外包朋友的反馈,写了这篇文章 ,希望对正在找工作的老铁有所帮助

Java校招入职华为,半年后我跑路了

何来 我,一个双非本科弟弟,有幸在 19 届的秋招中得到前东家华为(以下简称 hw)的赏识,当时秋招签订就业协议,说是入了某 java bg,之后一系列组织架构调整原因等等让人无法理解的神操作,最终毕业前夕,被通知调往其他 bg 做嵌入式开发(纯 C 语言)。 由于已至于校招末尾,之前拿到的其他 offer 又无法再收回,一时感到无力回天,只得默默接受。 毕业后,直接入职开始了嵌入式苦旅,由于从未...

Java基础知识面试题(2020最新版)

文章目录Java概述何为编程什么是Javajdk1.5之后的三大版本JVM、JRE和JDK的关系什么是跨平台性?原理是什么Java语言有哪些特点什么是字节码?采用字节码的最大好处是什么什么是Java程序的主类?应用程序和小程序的主类有何不同?Java应用程序与小程序之间有那些差别?Java和C++的区别Oracle JDK 和 OpenJDK 的对比基础语法数据类型Java有哪些数据类型switc...

@程序员:GitHub这个项目快薅羊毛

今天下午在朋友圈看到很多人都在发github的羊毛,一时没明白是怎么回事。 后来上百度搜索了一下,原来真有这回事,毕竟资源主义的羊毛不少啊,1000刀刷爆了朋友圈!不知道你们的朋友圈有没有看到类似的消息。 这到底是啥情况? 微软开发者平台GitHub 的一个区块链项目 Handshake ,搞了一个招募新会员的活动,面向GitHub 上前 25万名开发者派送 4,246.99 HNS币,大约价...

用python打开电脑摄像头,并把图像传回qq邮箱【Pyinstaller打包】

前言: 如何悄悄的打开朋友的摄像头,看看她最近过的怎么样,嘿嘿!这次让我带你们来实现这个功能。 注: 这个程序仅限在朋友之间开玩笑,别去搞什么违法的事情哦。 代码 发送邮件 使用python内置的email模块即可完成。导入相应的代码封装为一个send函数,顺便导入需要导入的包 注: 下面的代码有三处要修改的地方,两处写的qq邮箱地址,还有一处写的qq邮箱授权码,不知道qq邮箱授权码的可以去百度一...

做了5年运维,靠着这份监控知识体系,我从3K变成了40K

从来没讲过运维,因为我觉得运维这种东西不需要太多的知识面,然后我一个做了运维朋友告诉我大错特错,他就是从3K的运维一步步到40K的,甚至笑着说:我现在感觉自己什么都能做。 既然讲,就讲最重要的吧。 监控是整个运维乃至整个产品生命周期中最重要的一环,事前及时预警发现故障,事后提供详实的数据用于追查定位问题。目前业界有很多不错的开源产品可供选择。选择一款开源的监控系统,是一个省时省力、效率最高的方...

C++(继承):19---虚基类与虚继承(virtual)

一、菱形继承 在介绍虚继承之前介绍一下菱形继承 概念:A作为基类,B和C都继承与A。最后一个类D又继承于B和C,这样形式的继承称为菱形继承 菱形继承的缺点: 数据冗余:在D中会保存两份A的内容 访问不明确(二义性):因为D不知道是以B为中介去访问A还是以C为中介去访问A,因此在访问某些成员的时候会发生二义性 缺点的解决: 数据冗余:通过下面“虚继承”技术来解决(见下) 访问...

再不跳槽,应届毕业生拿的都比我多了!

跳槽几乎是每个人职业生涯的一部分,很多HR说“三年两跳”已经是一个跳槽频繁与否的阈值了,可为什么市面上有很多程序员不到一年就跳槽呢?他们不担心影响履历吗? PayScale之前发布的**《员工最短任期公司排行榜》中,两家码农大厂Amazon和Google**,以1年和1.1年的员工任期中位数分列第二、第四名。 PayScale:员工最短任期公司排行榜 意外的是,任期中位数极小的这两家公司,薪资...

我以为我学懂了数据结构,直到看了这个导图才发现,我错了

数据结构与算法思维导图

技术大佬:我去,你写的 switch 语句也太老土了吧

昨天早上通过远程的方式 review 了两名新来同事的代码,大部分代码都写得很漂亮,严谨的同时注释也很到位,这令我非常满意。但当我看到他们当中有一个人写的 switch 语句时,还是忍不住破口大骂:“我擦,小王,你丫写的 switch 语句也太老土了吧!” 来看看小王写的代码吧,看完不要骂我装逼啊。 private static String createPlayer(PlayerTypes p...

华为初面+综合面试(Java技术面)附上面试题

华为面试整体流程大致分为笔试,性格测试,面试,综合面试,回学校等结果。笔试来说,华为的难度较中等,选择题难度和网易腾讯差不多。最后的代码题,相比下来就简单很多,一共3道题目,前2题很容易就AC,题目已经记不太清楚,不过难度确实不大。最后一题最后提交的代码过了75%的样例,一直没有发现剩下的25%可能存在什么坑。 笔试部分太久远,我就不怎么回忆了。直接将面试。 面试 如果说腾讯的面试是挥金如土...

和黑客斗争的 6 天!

互联网公司工作,很难避免不和黑客们打交道,我呆过的两家互联网公司,几乎每月每天每分钟都有黑客在公司网站上扫描。有的是寻找 Sql 注入的缺口,有的是寻找线上服务器可能存在的漏洞,大部分都...

讲一个程序员如何副业月赚三万的真实故事

loonggg读完需要3分钟速读仅需 1 分钟大家好,我是你们的校长。我之前讲过,这年头,只要肯动脑,肯行动,程序员凭借自己的技术,赚钱的方式还是有很多种的。仅仅靠在公司出卖自己的劳动时...

win10暴力查看wifi密码

刚才邻居打了个电话说:喂小灰,你家wifi的密码是多少,我怎么连不上了。 我。。。 我也忘了哎,就找到了一个好办法,分享给大家: 第一种情况:已经连接上的wifi,怎么知道密码? 打开:控制面板\网络和 Internet\网络连接 然后右击wifi连接的无线网卡,选择状态 然后像下图一样: 第二种情况:前提是我不知道啊,但是我以前知道密码。 此时可以利用dos命令了 1、利用netsh wlan...

上班一个月,后悔当初着急入职的选择了

最近有个老铁,告诉我说,上班一个月,后悔当初着急入职现在公司了。他之前在美图做手机研发,今年美图那边今年也有一波组织优化调整,他是其中一个,在协商离职后,当时捉急找工作上班,因为有房贷供着,不能没有收入来源。所以匆忙选了一家公司,实际上是一个大型外包公司,主要派遣给其他手机厂商做外包项目。**当时承诺待遇还不错,所以就立马入职去上班了。但是后面入职后,发现薪酬待遇这块并不是HR所说那样,那个HR自...

女程序员,为什么比男程序员少???

昨天看到一档综艺节目,讨论了两个话题:(1)中国学生的数学成绩,平均下来看,会比国外好?为什么?(2)男生的数学成绩,平均下来看,会比女生好?为什么?同时,我又联想到了一个技术圈经常讨...

总结了 150 余个神奇网站,你不来瞅瞅吗?

原博客再更新,可能就没了,之后将持续更新本篇博客。

副业收入是我做程序媛的3倍,工作外的B面人生是怎样的?

提到“程序员”,多数人脑海里首先想到的大约是:为人木讷、薪水超高、工作枯燥…… 然而,当离开工作岗位,撕去层层标签,脱下“程序员”这身外套,有的人生动又有趣,马上展现出了完全不同的A/B面人生! 不论是简单的爱好,还是正经的副业,他们都干得同样出色。偶尔,还能和程序员的特质结合,产生奇妙的“化学反应”。 @Charlotte:平日素颜示人,周末美妆博主 大家都以为程序媛也个个不修边幅,但我们也许...

MySQL数据库面试题(2020最新版)

文章目录数据库基础知识为什么要使用数据库什么是SQL?什么是MySQL?数据库三大范式是什么mysql有关权限的表都有哪几个MySQL的binlog有有几种录入格式?分别有什么区别?数据类型mysql有哪些数据类型引擎MySQL存储引擎MyISAM与InnoDB区别MyISAM索引与InnoDB索引的区别?InnoDB引擎的4大特性存储引擎选择索引什么是索引?索引有哪些优缺点?索引使用场景(重点)...

女朋友过生日,我花了20分钟给她写了一个代理服务器

女朋友说:“看你最近挺辛苦的,我送你一个礼物吧。你看看想要什么,我来准备。” 我想了半天,从书到鞋子到电子产品最后到生活用品,感觉自己什么都不缺,然后和她说:“你省省钱吧,我什么都不需要。” 她坚持要送:“不行,你一定要说一个礼物,我想送你东西了。” 于是,我认真了起来,拿起手机,上淘宝逛了几分钟,但还是没能想出来缺点什么,最后实在没办法了:“这样吧,如果你实在想送东西,那你就写一个代理服务器吧”...

记一次腾讯面试,我挂在了最熟悉不过的队列上……

腾讯后台面试,面试官问:如何自己实现队列?

如果你是老板,你会不会踢了这样的员工?

有个好朋友ZS,是技术总监,昨天问我:“有一个老下属,跟了我很多年,做事勤勤恳恳,主动性也很好。但随着公司的发展,他的进步速度,跟不上团队的步伐了,有点...

我入职阿里后,才知道原来简历这么写

私下里,有不少读者问我:“二哥,如何才能写出一份专业的技术简历呢?我总感觉自己写的简历太烂了,所以投了无数份,都石沉大海了。”说实话,我自己好多年没有写过简历了,但我认识的一个同行,他在阿里,给我说了一些他当年写简历的方法论,我感觉太牛逼了,实在是忍不住,就分享了出来,希望能够帮助到你。 01、简历的本质 作为简历的撰写者,你必须要搞清楚一点,简历的本质是什么,它就是为了来销售你的价值主张的。往深...

程序员写出这样的代码,能不挨骂吗?

当你换槽填坑时,面对一个新的环境。能够快速熟练,上手实现业务需求是关键。但是,哪些因素会影响你快速上手呢?是原有代码写的不够好?还是注释写的不够好?昨夜...

带了6个月的徒弟当了面试官,而身为高级工程师的我天天修Bug......

即将毕业的应届毕业生一枚,现在只拿到了两家offer,但最近听到一些消息,其中一个offer,我这个组据说客户很少,很有可能整组被裁掉。 想问大家: 如果我刚入职这个组就被裁了怎么办呢? 大家都是什么时候知道自己要被裁了的? 面试软技能指导: BQ/Project/Resume 试听内容: 除了刷题,还有哪些技能是拿到offer不可或缺的要素 如何提升面试软实力:简历, 行为面试,沟通能...

!大部分程序员只会写3年代码

如果世界上都是这种不思进取的软件公司,那别说大部分程序员只会写 3 年代码,恐怕就没有程序员这种职业。

离职半年了,老东家又发 offer,回不回?

有小伙伴问松哥这个问题,他在上海某公司,在离职了几个月后,前公司的领导联系到他,希望他能够返聘回去,他很纠结要不要回去? 俗话说好马不吃回头草,但是这个小伙伴既然感到纠结了,我觉得至少说明了两个问题:1.曾经的公司还不错;2.现在的日子也不是很如意。否则应该就不会纠结了。 老实说,松哥之前也有过类似的经历,今天就来和小伙伴们聊聊回头草到底吃不吃。 首先一个基本观点,就是离职了也没必要和老东家弄的苦...

2020阿里全球数学大赛:3万名高手、4道题、2天2夜未交卷

阿里巴巴全球数学竞赛( Alibaba Global Mathematics Competition)由马云发起,由中国科学技术协会、阿里巴巴基金会、阿里巴巴达摩院共同举办。大赛不设报名门槛,全世界爱好数学的人都可参与,不论是否出身数学专业、是否投身数学研究。 2020年阿里巴巴达摩院邀请北京大学、剑桥大学、浙江大学等高校的顶尖数学教师组建了出题组。中科院院士、美国艺术与科学院院士、北京国际数学...

立即提问
相关内容推荐